|
@@ -0,0 +1,53 @@
|
|
|
+#!/bin/bash
|
|
|
+#
|
|
|
+# Copyright (c) 2005, 2006, 2007, 2008 Peter Palfrader <peter@palfrader.org>
|
|
|
+# Copyright (c) 2008 Jacob Appelbaum <jacob@appelbaum.net>
|
|
|
+#
|
|
|
+# Permission is hereby granted, free of charge, to any person obtaining
|
|
|
+# a copy of this software and associated documentation files (the
|
|
|
+# "Software"), to deal in the Software without restriction, including
|
|
|
+# without limitation the rights to use, copy, modify, merge, publish,
|
|
|
+# distribute, sublicense, and/or sell copies of the Software, and to
|
|
|
+# permit persons to whom the Software is furnished to do so, subject to
|
|
|
+# the following conditions:
|
|
|
+#
|
|
|
+# The above copyright notice and this permission notice shall be
|
|
|
+# included in all copies or substantial portions of the Software.
|
|
|
+#
|
|
|
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
|
|
|
+# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
|
|
|
+# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
|
|
|
+# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
|
|
|
+# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
|
|
|
+# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
|
|
|
+# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
|
|
|
+#
|
|
|
+# This small script fetches information about a server when given a nickname.
|
|
|
+# It currently uses the v2 dir information and not the v3 consensus by default.
|
|
|
+# It requires wget, perl, awk to function properly. This is based on a zsh
|
|
|
+# dotfile from weasel and adapted to be a small bash utility.
|
|
|
+#
|
|
|
+
|
|
|
+set -u;
|
|
|
+set -e;
|
|
|
+
|
|
|
+# Feel free to set any authority you desire, we're using weasel's by default
|
|
|
+# You could also try the v3 directory infomation in weasel's dir authority:
|
|
|
+# http://tor.noreply.org:80/tor/status/authority
|
|
|
+#
|
|
|
+authority="http://tor.noreply.org:80/tor/status/authority";
|
|
|
+
|
|
|
+nickname="$1";
|
|
|
+
|
|
|
+fp=`wget -q -O - $authority | \
|
|
|
+ awk '$1 == "r" && $2 == "'$nickname'" {printf "%s===", $3}' | \
|
|
|
+ perl -MMIME::Base64 -e "print unpack(\"H*\", decode_base64(<>)),\"\n\"";`
|
|
|
+
|
|
|
+if [ "$fp" != "" ];
|
|
|
+then
|
|
|
+ wget -q -O - http://tor.noreply.org:80/tor/server/fp/$fp;
|
|
|
+ exit $?;
|
|
|
+else
|
|
|
+ echo "It appears the nickname is not currently known by the directory authority.";
|
|
|
+ exit 1;
|
|
|
+fi
|